//
//  PieView.m
//  EmbedText
//
//  Created by 兖志飞 on 16/4/13.
//  Copyright © 2016年 兖志飞. All rights reserved.
//

#import "PieView.h"

@interface PieView()
@property (nonatomic,strong)NSTimer *timer1;
@property (nonatomic)float t;
@property (nonatomic,strong)NSArray *array;
@property (nonatomic)float time;
@property (nonatomic)float radous;
@property (nonatomic,strong)UILabel *label;
@end
@implementation PieView
// 1.先走init方法；
- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor redColor];
        self.timer1 =[NSTimer scheduledTimerWithTimeInterval:0.01 target:self selector:@selector(lll) userInfo:nil repeats:YES];
        self.t = 0;
        _time = 100;
       // _array = @[@{@"x":@"20",@"y":@"20"},@{@"x":@"60",@"y":@"80"},@{@"x":@"100",@"y":@"200"},@{@"x":@"140",@"y":@"400"},@{@"x":@"160",@"y":@"100"}];
        // 圆弧
        _array =@[@"1",@"4",@"3",@"2"];
       
    }
    return self;
  
}
- (void)lll{
    [self setNeedsDisplay];
}
//2.在走drawRect方法;
- (void)drawRect:(CGRect)rect{
    [super drawRect:rect];
    self.radous = rect.size.width < rect.size.height?rect.size.width/2:rect.size.height/2;
    self.t++;
    float y = 0;
     CGContextRef context = UIGraphicsGetCurrentContext();
    //CGContextScaleCTM(context,1, _t*1/_time);
   //CGContextTranslateCTM(context, rect.origin.x, rect.origin.y);//4
   //CGContextTranslateCTM(context, 0, rect.size.height);//3
   // CGContextScaleCTM(context, 1.0, -1.0);//2
   // CGContextTranslateCTM(context, -rect.origin.x, -rect.origin.y);//1
    
    //画扇醒；从负值开始画；
    for (int i = 0; i<_array.count; i++) {
        float x = [_array[i]  floatValue]/10.0;
        if (i> 0) {
            float num = [_array[i-1] floatValue]/10.0;
            y+=num;
        }
        UIColor *color1 = [self colorWithHex:@"#00ffff" andAlpha:1];
        UIColor *aColor = [UIColor colorWithRed:y green:x blue:0 alpha:1];
         //CGContextSetLineWidth(context, 10.0);
        CGContextSetStrokeColorWithColor(context,color1.CGColor);
        CGContextSetFillColorWithColor(context, aColor.CGColor);//填充颜色
        CGContextMoveToPoint(context,rect.size.width/2,rect.size.height/2);
        if (i==0) {
              CGContextAddArc(context, rect.size.width/2, rect.size.height/2, self.radous-1, y* (_t* 2 * M_PI/ _time),x* (_t* 2 * M_PI/ _time), 0);
        }else if(i < _array.count){
           // CGContextAddArc(context, 100, 100, 100, y* 2 * M_PI,y* (2 * M_PI)+x*( _t* 2 * M_PI/ _time), 0);
//           
        CGContextAddArc(context, rect.size.width/2, rect.size.height/2, self.radous-1,y* (_t* 2 * M_PI/ _time),y* (_t* 2 * M_PI/ _time)+x*(_t* 2 * M_PI/ _time), 0);
        }
        CGContextClosePath(context);
        CGContextDrawPath(context, kCGPathFillStroke);
    }
    
    UIColor *aColor = [UIColor colorWithRed:0.6 green:0.5 blue:0.3 alpha:1];
    //CGContextSetLineWidth(context, 10.0);
    CGContextSetStrokeColorWithColor(context,aColor.CGColor);
    CGContextSetFillColorWithColor(context, aColor.CGColor);//填充颜色
    CGContextMoveToPoint(context, rect.size.width/2, rect.size.height/2);
    CGContextAddArc(context, rect.size.width/2, rect.size.height/2, self.radous/2,0,(_t* 2 * M_PI/ _time), 0);
    CGContextClosePath(context);
    CGContextDrawPath(context, kCGPathFillStroke);

    if (_t >= _time) {
        [self.timer1 invalidate];
        [self derawname:context rect:rect];
      
    }
   // CGContextStrokePath(context);
}
- (void)derawname:(CGContextRef)context rect:(CGRect)rect{
    UIFont  *font = [UIFont boldSystemFontOfSize:18.0];
    UIColor *color = [UIColor whiteColor];
    float y = 0;

    for (int i = 0; i<_array.count; i++) {
        float x = [_array[i]  floatValue];
        if (i!= 0) {
            float t = [_array[i-1]  floatValue];
            y+=t;
        }
        NSArray *array = @[@"第一",@"第二",@"第三名",@"其他"];
        NSMutableParagraphStyle *paragraphStyle = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
        /// Set line break mode
        paragraphStyle.lineBreakMode = NSLineBreakByTruncatingTail;
        paragraphStyle.alignment =  NSTextAlignmentCenter;
        /// Set text alignment
       
        [array[i] drawInRect:CGRectMake(rect.size.width/2+3*self.radous/4*cos(2*M_PI/10*(y+x/2))-30, rect.size.height/2+3*self.radous/4*sin(2*M_PI/10*(y+x/2))-10 , 60, 20) withAttributes:@{NSFontAttributeName:font,NSForegroundColorAttributeName:color,NSParagraphStyleAttributeName:paragraphStyle}];
//        NSString *t = [NSString stringWithFormat:@"只能\n122132"];
        /// Set line break mode
        _label = [[UILabel alloc]init];
        _label.text = @"你好啊\n旅行者Q!!!";
        _label.numberOfLines = 0;
        _label.textColor = [UIColor greenColor];
        _label.font = [UIFont systemFontOfSize:20];
        _label.frame = CGRectMake(rect.size.width/2-50,rect.size.height/2-50 , 2*_radous , 100);
        _label.textAlignment = NSTextAlignmentCenter;
        _label.center = self.center;
        [self addSubview:_label];
//        self.backgroundColor = [UIColor redColor];
//        [t drawInRect:CGRectMake(rect.size.width/2-50, rect.size.height/2-50 ,100, 100) withAttributes:@{NSFontAttributeName:font,NSForegroundColorAttributeName:color,NSParagraphStyleAttributeName:paragraphStyle}];
    }
}
- (UIColor*)colorWithHex:(NSString*)hex andAlpha:(float)alpha{
    hex = [hex stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    if (!hex || [hex length] != 7) {
        return [UIColor clearColor];
    }
    unsigned red = 256, green = 256, blue = 256;
    
    NSRange redRange = {1,2};
    NSScanner *scanner = [NSScanner scannerWithString:[hex substringWithRange:redRange]];
    [scanner scanHexInt:&red];
    NSLog(@"%d",red);
    
    NSRange greenRange = {3,2};
    scanner = [NSScanner scannerWithString:[hex substringWithRange:greenRange]];
    [scanner scanHexInt:&green];
    
    NSRange blueRange = {5,2};
    scanner = [NSScanner scannerWithString:[hex substringWithRange:blueRange]];
    [scanner scanHexInt:&blue];
    
    if (red == 256 || green == 256 || blue == 256) {
        return nil;
    }
    else {
        return [UIColor colorWithRed:red/255.0f green:green/255.0f blue:blue/255.0f alpha:alpha];
    }
}
@end
