//
//  CircleView.m
//  EmbedText
//
//  Created by 兖志飞 on 16/4/14.
//  Copyright © 2016年 兖志飞. All rights reserved.
//

#import "CircleView.h"

@implementation CircleView

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        self.timer1 =[NSTimer scheduledTimerWithTimeInterval:0.04 target:self selector:@selector(lll) userInfo:nil repeats:YES];
        self.t = 29;
        _time = 30;
        _value = 0.9;
        self.radius = 100;
        _label = [[UILabel alloc]init];
        _label.text = @"你好啊\n旅行者Q!!!";
        _label.numberOfLines = 0;
        _label.textColor = [UIColor greenColor];
        _label.font = [UIFont systemFontOfSize:20];
        _label.frame = CGRectMake(0 , 0, 2*_radius , 60);
        _label.textAlignment = NSTextAlignmentCenter;
        _label.center = self.center;
        [self addSubview:_label];
        self.backgroundColor = [UIColor redColor];
    }
    return self;
}
- (void)drawRect:(CGRect)rect{
    [super drawRect:rect];
    _t++;
    CGContextRef context = UIGraphicsGetCurrentContext();
    UIColor *color =[self colorWithHex:@"#cccccc" andAlpha:1];
    CGContextSetStrokeColorWithColor(context,color.CGColor);
    CGContextSetLineWidth(context, 6);
    CGContextAddArc(context, rect.size.width/2, rect.size.height/2, _radius-3, 0, 2*M_PI, 0);
    CGContextStrokePath(context);
    if (_t  <= _time) {
        UIColor *color =[self colorWithHex:@"#00ff00" andAlpha:0.8];
        CGContextSetStrokeColorWithColor(context,color.CGColor);
        CGContextSetLineWidth(context, 6);
        CGContextAddArc(context, rect.size.width/2, rect.size.height/2, _radius-3,-M_PI/2, _t*2*M_PI/_time *_value-M_PI/2, 0);
        CGContextStrokePath(context);
    }
    if (_t == _time) {
        [self.timer1 invalidate];
    }
    
}
//- (void)derawname:(CGContextRef)context
//                   rect:(CGRect)Rect{
//        UIFont  *font = [UIFont boldSystemFontOfSize:20.0];
//        UIColor *color = [UIColor redColor];
//        NSMutableParagraphStyle *paragraphStyle = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
//        /// Set line break mode
//       // paragraphStyle.lineBreakMode = NSLineBreakByTruncatingTail;
//        paragraphStyle.alignment=NSTextAlignmentNatural;
//    
//        /// Set text alignment
//        paragraphStyle.alignment = NSTextAlignmentCenter;
//        [_label.text drawInRect:Rect withAttributes:@{NSFontAttributeName:font,NSForegroundColorAttributeName:color,NSParagraphStyleAttributeName:paragraphStyle}];
//
//    
//}
- (void)lll{
    [self setNeedsDisplay];
}

- (UIColor*)colorWithHex:(NSString*)hex andAlpha:(float)alpha{
    hex = [hex stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    if (!hex || [hex length] != 7) {
        return [UIColor clearColor];
    }
    unsigned red = 256, green = 256, blue = 256;
    
    NSRange redRange = {1,2};
    NSScanner *scanner = [NSScanner scannerWithString:[hex substringWithRange:redRange]];
    [scanner scanHexInt:&red];
    
    NSRange greenRange = {3,2};
    scanner = [NSScanner scannerWithString:[hex substringWithRange:greenRange]];
    [scanner scanHexInt:&green];
    
    NSRange blueRange = {5,2};
    scanner = [NSScanner scannerWithString:[hex substringWithRange:blueRange]];
    [scanner scanHexInt:&blue];
    
    if (red == 256 || green == 256 || blue == 256) {
        return nil;
    }
    else {
        return [UIColor colorWithRed:red/255.0f green:green/255.0f blue:blue/255.0f alpha:alpha];
    }
}
@end
