//
//  RectView.m
//  EmbedText
//
//  Created by 兖志飞 on 16/4/19.
//  Copyright © 2016年 兖志飞. All rights reserved.
//

#import "RectView.h"
#define SPACINGX 40
#define SPACINGY 20
#define SPACINGL 10
@implementation RectView

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        self.array = [NSMutableArray array];
    }
    return self;
}

- (void)layoutSubviews{
    [self drawXY];
     NSArray *array1 = @[@"51",@"74",@"99",@"95",@"74",@"23",@"145"];
     NSArray *array2 = @[@"53",@"4",@"99",@"98",@"71",@"53",@"15"];
     NSArray *array3 = @[@"5",@"14",@"99",@"98",@"71",@"153",@"115"];
    [self.array addObject:array1];
    //[self.array addObject:array2];
    //[self.array addObject:array3];
    [self drawRectLine:self.array];
   //self.layer.transform = CATransform3DMakeRotation(M_PI/2,0,0,1);
    //self.frame = CGRectMake(self.frame.origin.y ,self.frame.origin.x,self.frame.size.height,self.frame.size.width);
}
- (void)drawRectLine:(NSMutableArray *)arry{
    NSLog(@"%@",arry);
    for (int j=0; j< arry.count; j++) {
        NSArray *array1 = arry[j];
        for (int i = 0; i < array1.count; i++) {
            CAShapeLayer *layer = [CAShapeLayer layer];
            if (j== 0) {
                 layer.strokeColor = [UIColor redColor].CGColor;
            }else if(j ==1){
            layer.strokeColor = [UIColor greenColor].CGColor;
            }else{
            layer.strokeColor = [UIColor blueColor].CGColor;
            }
            layer.fillColor = [UIColor clearColor].CGColor;
            layer.lineWidth = ((self.frame.size.width - 2*SPACINGX)/7.0 -SPACINGL)/arry.count;
            UIBezierPath *path = [UIBezierPath bezierPath];
            
            float t = [array1[i] floatValue];
            t = [self Mactfloat:t];
            [path moveToPoint:CGPointMake(SPACINGX+SPACINGL+ layer.lineWidth/2+(self.frame.size.width - 2*SPACINGX)/7.0*i+ layer.lineWidth*j, self.frame.size.height - SPACINGY-1)];
            [path addLineToPoint:CGPointMake(SPACINGX+SPACINGL+ layer.lineWidth/2+(self.frame.size.width - 2*SPACINGX)/7.0*i+ layer.lineWidth*j,t)];
            layer.path = path.CGPath;
            [self AddCabasicAnimation:1 CaShapeLayer:layer];
     
            [self.layer addSublayer:layer];
    }
    }
}
//处理坐标；
- (CGFloat )Mactfloat:(CGFloat)num{
    num = self.frame.size.height-SPACINGY - (num)/200*(self.frame.size.height - 2*SPACINGY);
    return num;
}
//动画；
- (void)AddCabasicAnimation:(float )time CaShapeLayer:(CAShapeLayer *)layer{
    CABasicAnimation *pathAnimation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    pathAnimation.duration =time;
    pathAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    pathAnimation.fromValue = [NSNumber numberWithFloat:0.0f];
    pathAnimation.toValue = [NSNumber numberWithFloat:1.0f];
    pathAnimation.autoreverses = NO;
    [layer addAnimation:pathAnimation forKey:@"strokeEndAnimation"];
    
}

- (void)drawXY{
    CAShapeLayer *layer = [CAShapeLayer layer];
    layer.lineWidth = 2;
    //layer.fillColor = [UIColor grayColor].CGColor;
    layer.lineCap       = kCALineCapSquare;
    layer.strokeColor = [UIColor colorWithRed:0.3 green:0.3 blue:0.3 alpha:1].CGColor;
    UIBezierPath *path = [UIBezierPath bezierPath];
    [path moveToPoint:CGPointMake(SPACINGX,self.frame.size.height - SPACINGY)];
    [path addLineToPoint:CGPointMake(SPACINGX, SPACINGY)];
    [path moveToPoint:CGPointMake(SPACINGX,self.frame.size.height - SPACINGY)];
    [path addLineToPoint:CGPointMake(self.frame.size.width-SPACINGX, self.frame.size.height - SPACINGY)];
    layer.path = path.CGPath;
    [self.layer addSublayer:layer];
    
    for (int i = 0; i < 7; i++) {
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake((self.frame.size.width - 2*SPACINGX)/7.0 * i + SPACINGX +SPACINGL, self.frame.size.height - SPACINGY,  (self.frame.size.width - 2*SPACINGX)/7.0-SPACINGL, SPACINGY)];
        label.font = [UIFont systemFontOfSize:12];
       // label.center = CGPointMake((self.frame.size.width - SPACINGX-1)/7.0 * (i+1/2.0) + SPACINGX ,self.frame.size.height - SPACINGY/2);
        label.textAlignment = NSTextAlignmentCenter;
        label.textColor = self.backgroundColor;
        //label.backgroundColor = [UIColor greenColor];
        label.text = [NSString stringWithFormat:@"星期%d",i+1];
        [self addSubview:label];
    }
    for (int i = 0; i < 7; i++) {
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, SPACINGX, 35)];
        label.font = [UIFont systemFontOfSize:12];
        label.center = CGPointMake(SPACINGX/2-3,self.frame.size.height - (self.frame.size.height - 2*SPACINGY)/6.0 * i-SPACINGY);
        label.textAlignment = NSTextAlignmentRight;
        label.textColor = self.backgroundColor;
        //label.backgroundColor = [UIColor greenColor];
        label.text = [NSString stringWithFormat:@"%0.1f",200/6.0*i];
        [self addSubview:label];
    }
    
}



@end
